VTK: vtkSmoothErrorMetric Class Reference

| VTK 9.3.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkSmoothErrorMetric Class Reference

Objects that compute geometry-based error during cell tessellation according to some max angle. More...

`#include <vtkSmoothErrorMetric.h>`

Inheritance diagram for vtkSmoothErrorMetric:
[legend]
Collaboration diagram for vtkSmoothErrorMetric:
[legend]

## Public Member Functions
double | GetAngleTolerance ()
| Return the flatness threshold. More...
void | SetAngleTolerance (double value)
| Set the flatness threshold with an angle in degrees. More...
int | RequiresEdgeSubdivision (double *leftPoint, double *midPoint, double *rightPoint, double alpha) override
| Does the edge need to be subdivided according to the cosine between the two chords passing through the mid-point and the endpoints? The edge is defined by its ‘leftPoint’ and its ‘rightPoint’. More...
double | GetError (double *leftPoint, double *midPoint, double *rightPoint, double alpha) override
| Return the error at the mid-point. More...
Public Member Functions inherited from vtkGenericSubdivisionErrorMetric
void | SetGenericCell (vtkGenericAdaptorCell *cell)
| The cell that the edge belongs to. More...
virtual vtkGenericAdaptorCell * | GetGenericCell ()
| The cell that the edge belongs to. More...
void | SetDataSet (vtkGenericDataSet *ds)
| Set/Get the dataset to be tessellated. More...
virtual vtkGenericDataSet * | GetDataSet ()
| Set/Get the dataset to be tessellated. More...
vtkGenericSubdivisionErrorMetric * | NewInstance () const
| Standard VTK type and error macros. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkSmoothErrorMetric * | New ()
| Construct the error metric with a default flatness threshold of 90.1 degrees. More...
Static Public Member Functions inherited from vtkGenericSubdivisionErrorMetric
static vtkTypeBool | IsTypeOf (const char *type)
| Standard VTK type and error macros. More...
static vtkGenericSubdivisionErrorMetric * | SafeDownCast (vtkObjectBase *o)
| Standard VTK type and error macros. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
| vtkSmoothErrorMetric ()
| ~vtkSmoothErrorMetric () override
Protected Member Functions inherited from vtkGenericSubdivisionErrorMetric
| vtkGenericSubdivisionErrorMetric ()
| ~vtkGenericSubdivisionErrorMetric () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
double | AngleTolerance
double | CosTolerance
Protected Attributes inherited from vtkGenericSubdivisionErrorMetric
vtkGenericAdaptorCell * | GenericCell
vtkGenericDataSet * | DataSet
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
typedef vtkGenericSubdivisionErrorMetric | Superclass
| Standard VTK type and error macros. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard VTK type and error macros. More...
static vtkSmoothErrorMetric * | SafeDownCast (vtkObjectBase *o)
| Standard VTK type and error macros. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard VTK type and error macros. More...
vtkSmoothErrorMetric * | NewInstance () const
| Standard VTK type and error macros. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard VTK type and error macros. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard VTK type and error macros. More...

## Additional Inherited Members
Public Types inherited from vtkGenericSubdivisionErrorMetric
typedef vtkObject | Superclass
| Standard VTK type and error macros. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

Objects that compute geometry-based error during cell tessellation according to some max angle.

It is a concrete error metric, based on a geometric criterium: a max angle between the chord passing through the midpoint and one of the endpoints and the other chord passing through the midpoint and the other endpoint of the edge. It is related to the flatness of an edge.

See also
  vtkGenericCellTessellator vtkGenericSubdivisionErrorMetric

Tests:
  vtkSmoothErrorMetric (Tests)

Definition at line 31 of file vtkSmoothErrorMetric.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkGenericSubdivisionErrorMetric vtkSmoothErrorMetric::Superclass

Standard VTK type and error macros.

Definition at line 44 of file vtkSmoothErrorMetric.h.

## Constructor & Destructor Documentation

## ◆ vtkSmoothErrorMetric()

vtkSmoothErrorMetric::vtkSmoothErrorMetric | ( |  | ) |
| protected

## ◆ ~vtkSmoothErrorMetric()

vtkSmoothErrorMetric::~vtkSmoothErrorMetric | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkSmoothErrorMetric* vtkSmoothErrorMetric::New | ( |  | ) |
| static

Construct the error metric with a default flatness threshold of 90.1 degrees.

## ◆ IsTypeOf()

static vtkTypeBool vtkSmoothErrorMetric::IsTypeOf | ( | const char * | type | ) |
| static

Standard VTK type and error macros.

## ◆ IsA()

virtual vtkTypeBool vtkSmoothErrorMetric::IsA | ( | const char * | type | ) |
| virtual

Standard VTK type and error macros.

Reimplemented from vtkGenericSubdivisionErrorMetric.

## ◆ SafeDownCast()

static vtkSmoothErrorMetric* vtkSmoothErrorMetric::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard VTK type and error macros.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkSmoothErrorMetric::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard VTK type and error macros.

Reimplemented from vtkGenericSubdivisionErrorMetric.

## ◆ NewInstance()

vtkSmoothErrorMetric* vtkSmoothErrorMetric::NewInstance | ( |  | ) | const

Standard VTK type and error macros.

## ◆ PrintSelf()

void vtkSmoothErrorMetric::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard VTK type and error macros.

Reimplemented from vtkGenericSubdivisionErrorMetric.

## ◆ GetAngleTolerance()

double vtkSmoothErrorMetric::GetAngleTolerance | ( |  | ) |

Return the flatness threshold.

Postcondition
  positive_result: result>90 && result<180

## ◆ SetAngleTolerance()

void vtkSmoothErrorMetric::SetAngleTolerance | ( | double | value | ) |

Set the flatness threshold with an angle in degrees.

Internally compute the cosine. value is supposed to be in ]90,180[, if not it is clamped in [90.1,179.9]. For instance 178 will give better result than 150.

## ◆ RequiresEdgeSubdivision()

int vtkSmoothErrorMetric::RequiresEdgeSubdivision | ( | double * | leftPoint,
|  | double * | midPoint,
|  | double * | rightPoint,
|  | double | alpha
| ) |  |
| overridevirtual

Does the edge need to be subdivided according to the cosine between the two chords passing through the mid-point and the endpoints? The edge is defined by its ‘leftPoint’ and its ‘rightPoint’.

‘leftPoint’, ‘midPoint’ and ‘rightPoint’ have to be initialized before calling RequiresEdgeSubdivision(). Their format is global coordinates, parametric coordinates and point centered attributes: xyx rst abc de... ‘alpha’ is the normalized abscissa of the midpoint along the edge. (close to 0 means close to the left point, close to 1 means close to the right point)

Precondition
  leftPoint_exists: leftPoint!=0
  midPoint_exists: midPoint!=0
  rightPoint_exists: rightPoint!=0
  clamped_alpha: alpha>0 && alpha<1
  valid_size: sizeof(leftPoint)=sizeof(midPoint)=sizeof(rightPoint) =GetAttributeCollection()->GetNumberOfPointCenteredComponents()+6

Implements vtkGenericSubdivisionErrorMetric.

## ◆ GetError()

double vtkSmoothErrorMetric::GetError | ( | double * | leftPoint,
|  | double * | midPoint,
|  | double * | rightPoint,
|  | double | alpha
| ) |  |
| overridevirtual

Return the error at the mid-point.

It will return an error relative to the bounding box size if GetRelative() is true, a square absolute error otherwise. See RequiresEdgeSubdivision() for a description of the arguments.

Precondition
  leftPoint_exists: leftPoint!=0
  midPoint_exists: midPoint!=0
  rightPoint_exists: rightPoint!=0
  clamped_alpha: alpha>0 && alpha<1
  valid_size: sizeof(leftPoint)=sizeof(midPoint)=sizeof(rightPoint) =GetAttributeCollection()->GetNumberOfPointCenteredComponents()+6

Postcondition
  positive_result: result>=0

Implements vtkGenericSubdivisionErrorMetric.

## Member Data Documentation

## ◆ AngleTolerance

double vtkSmoothErrorMetric::AngleTolerance
| protected

Definition at line 102 of file vtkSmoothErrorMetric.h.

## ◆ CosTolerance

double vtkSmoothErrorMetric::CosTolerance
| protected

Definition at line 103 of file vtkSmoothErrorMetric.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkSmoothErrorMetric.h